import pytest
import allure
from Homework_files.APITesting_LZJ.common.read_excel import ReadExcel
from Homework_files.APITesting_LZJ import log_decorator
from Homework_files.APITesting_LZJ import USERNAME

class TestBPM:
    @log_decorator
    @allure.epic("BPM-Basic")
    @pytest.mark.parametrize("module_name, api_name, level, case_title, case_method, case_url, case_mime, case_data, expect_data, sql_type, sql_data, update_key", ReadExcel(USERNAME).get_data())
    def test_bpm(self, req_fix, db_fix, module_name, api_name, level, case_title, case_method, case_url, case_mime, case_data, expect_data, sql_type, sql_data, update_key):
        allure.dynamic.feature(module_name)
        allure.dynamic.story(api_name)
        allure.dynamic.title(case_title)
        allure.dynamic.severity(level)
        print(case_method, case_url, case_mime, case_data, expect_data, sql_type, sql_data, update_key)
        if sql_type == "delete":
            db_fix.delete(sql_data)
        elif sql_type == "select":
            select_result = db_fix.select(sql_data)
            case_data[update_key] = select_result
        elif sql_type == "select|delete" or sql_type == "delete|select":
            db_fix.delete(sql_data["delete"])
            select_result = db_fix.select(sql_data["select"])
            case_data[update_key] = select_result
        result = req_fix.request_all(req_method=case_method, req_url=case_url, req_mime=case_mime, case_data=case_data)
        print(result.text)
        try:
            for key in expect_data:
                assert expect_data[key] == result.json().get(key)
        except AssertionError:
            raise AssertionError("断言失败，描述失败的原因")
        else:
            print("断言成功")